glibmm: Gio::Menu Class Reference

glibmm 2.38.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::Menu Class Reference

A simple implementation of MenuModel. More...

`#include <giomm/menu.h>`

Inheritance diagram for Gio::Menu:
[legend]

## Public Member Functions
virtual | ~Menu ()
GMenu* | gobj ()
| Provides access to the underlying C GObject. More...
const GMenu* | gobj () const
| Provides access to the underlying C GObject. More...
GMenu* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | freeze ()
| Marks menu as frozen. More...
void | insert_item (int position, const Glib::RefPtr< MenuItem >& item)
| Inserts item into menu. More...
void | prepend_item (const Glib::RefPtr< MenuItem >& item)
| Prepends item to the start of menu. More...
void | append_item (const Glib::RefPtr< MenuItem >& item)
| Appends item to the end of menu. More...
void | remove (int position)
| Removes an item from the menu. More...
void | remove_all ()
| Removes all items in the menu. More...
void | insert (int position, const Glib::ustring& label, const Glib::ustring& detailed_action=Glib::ustring())
| Convenience function for inserting a normal menu item into menu. More...
void | prepend (const Glib::ustring& label, const Glib::ustring& detailed_action=Glib::ustring())
| Convenience function for prepending a normal menu item to the start of menu. More...
void | append (const Glib::ustring& label, const Glib::ustring& detailed_action=Glib::ustring())
| Convenience function for appending a normal menu item to the end of menu. More...
void | insert_section (int position, const Glib::ustring& label, const Glib::RefPtr< MenuModel >& section)
| Convenience function for inserting a section menu item into menu. More...
void | insert_section (int position, const Glib::RefPtr< MenuModel >& section)
| A insert_section() convenience overload. More...
void | prepend_section (const Glib::ustring& label, const Glib::RefPtr< MenuModel >& section)
| Convenience function for prepending a section menu item to the start of menu. More...
void | prepend_section (const Glib::RefPtr< MenuModel >& section)
| A prepend_section() convenience overload. More...
void | append_section (const Glib::ustring& label, const Glib::RefPtr< MenuModel >& section)
| Convenience function for appending a section menu item to the end of menu. More...
void | append_section (const Glib::RefPtr< MenuModel >& section)
| A append_section() convenience overload. More...
void | insert_submenu (int position, const Glib::ustring& label, const Glib::RefPtr< MenuModel >& submenu)
| Convenience function for inserting a submenu menu item into menu. More...
void | prepend_submenu (const Glib::ustring& label, const Glib::RefPtr< MenuModel >& submenu)
| Convenience function for prepending a submenu menu item to the start of menu. More...
void | append_submenu (const Glib::ustring& label, const Glib::RefPtr< MenuModel >& submenu)
| Convenience function for appending a submenu menu item to the end of menu. More...
Public Member Functions inherited from Gio::MenuModel
virtual | ~MenuModel ()
GMenuModel* | gobj ()
| Provides access to the underlying C GObject. More...
const GMenuModel* | gobj () const
| Provides access to the underlying C GObject. More...
GMenuModel* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::VariantBase | get_item_attribute (int item_index, MenuAttribute attribute, const Glib::VariantType& expected_type)
| Queries the item at position item_index in model for the attribute specified by attribute. More...
const Glib::VariantBase | get_item_attribute (int item_index, MenuAttribute attribute, const Glib::VariantType& expected_type) const
| Queries the item at position item_index in model for the attribute specified by attribute. More...
Glib::RefPtr< MenuModel > | get_item_link (int item_index, MenuLink link)
| Queries the item at position item_index in model for the link specified by link. More...
Glib::RefPtr< const MenuModel > | get_item_link (int item_index, MenuLink link) const
| Queries the item at position item_index in model for the link specified by link. More...
bool | is_mutable () const
| Queries if model is mutable. More...
int | get_n_items () const
| Query the number of items in model. More...
Glib::RefPtr< MenuAttributeIter > | iterate_item_attributes (int item_index)
| Creates a MenuAttributeIter to iterate over the attributes of the item at position item_index in model. More...
Glib::RefPtr< const MenuAttributeIter > | iterate_item_attributes (int item_index) const
| Creates a MenuAttributeIter to iterate over the attributes of the item at position item_index in model. More...
Glib::RefPtr< MenuLinkIter > | iterate_item_links (int item_index)
| Creates a MenuLinkIter to iterate over the links of the item at position item_index in model. More...
Glib::RefPtr< const MenuLinkIter > | iterate_item_links (int item_index) const
| Creates a MenuLinkIter to iterate over the links of the item at position item_index in model. More...
void | items_changed (int position, int removed, int added)
| Requests emission of the MenuModel::signal_items_changed() signal on model. More...
Public Member Functions inherited from Glib::Object
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< Menu > | create ()
Static Public Member Functions inherited from Gio::MenuModel
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| Menu ()
Protected Member Functions inherited from Gio::MenuModel
| MenuModel ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
virtual | ~Object ()
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
virtual | ~ObjectBase ()=0
void | initialize (GObject* castitem)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::Menu > | wrap (GMenu* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gio::MenuModel
Glib::RefPtr< Gio::MenuModel > | wrap (GMenuModel* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(* | DestroyNotify )(gpointer data)

## Detailed Description

A simple implementation of MenuModel.

You populate a Menu by adding MenuItem instances to it.

There are some convenience methods to allow you to directly add items (avoiding MenuItem) for the common cases. To add a regular item, use insert(). To add a section, use insert_section(). To add a submenu, use insert_submenu().

Since glibmm 2.32:

## Constructor & Destructor Documentation

virtual Gio::Menu::~Menu | ( |  | ) |
| virtual

Gio::Menu::Menu | ( |  | ) |
| protected

## Member Function Documentation

void Gio::Menu::append | ( | const Glib::ustring& | label,
|  | const Glib::ustring& | detailed_action = `Glib::ustring()`
| ) |  |

Convenience function for appending a normal menu item to the end of menu.

Combine g_menu_item_new() and g_menu_insert_item() for a more flexible alternative.

Since glibmm 2.32:

Parameters

  label | The section label, or `0`.
  detailed_action | The detailed action string, or `0`.

void Gio::Menu::append_item | ( | const Glib::RefPtr< MenuItem >& | item | ) |

Appends item to the end of menu.

See g_menu_insert_item() for more information.

Since glibmm 2.32:

Parameters

  item | A MenuItem to append.

void Gio::Menu::append_section | ( | const Glib::ustring& | label,
|  | const Glib::RefPtr< MenuModel >& | section
| ) |  |

Convenience function for appending a section menu item to the end of menu.

Combine g_menu_item_new_section() and g_menu_insert_item() for a more flexible alternative.

Since glibmm 2.32:

Parameters

  label | The section label, or `0`.
  section | A MenuModel with the items of the section.

void Gio::Menu::append_section | ( | const Glib::RefPtr< MenuModel >& | section | ) |

A append_section() convenience overload.

void Gio::Menu::append_submenu | ( | const Glib::ustring& | label,
|  | const Glib::RefPtr< MenuModel >& | submenu
| ) |  |

Convenience function for appending a submenu menu item to the end of menu.

Combine g_menu_item_new_submenu() and g_menu_insert_item() for a more flexible alternative.

Since glibmm 2.32:

Parameters

  label | The section label, or `0`.
  submenu | A MenuModel with the items of the submenu.

static Glib::RefPtr<Menu> Gio::Menu::create | ( |  | ) |
| static

void Gio::Menu::freeze | ( |  | ) |

Marks menu as frozen.

After the menu is frozen, it is an error to attempt to make any changes to it. In effect this means that the Menu API must no longer be used.

This function causes g_menu_model_is_mutable() to begin returning `false`, which has some positive performance implications.

Since glibmm 2.32:

static GType Gio::Menu::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GMenu* Gio::Menu::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GMenu* Gio::Menu::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GMenu* Gio::Menu::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

void Gio::Menu::insert | ( | int | position,
|  | const Glib::ustring& | label,
|  | const Glib::ustring& | detailed_action = `Glib::ustring()`
| ) |  |

Convenience function for inserting a normal menu item into menu.

Combine g_menu_item_new() and g_menu_insert_item() for a more flexible alternative.

Since glibmm 2.32:

Parameters

  position | The position at which to insert the item.
  label | The section label, or `0`.
  detailed_action | The detailed action string, or `0`.

void Gio::Menu::insert_item | ( | int | position,
|  | const Glib::RefPtr< MenuItem >& | item
| ) |  |

Inserts item into menu.

The "insertion" is actually done by copying all of the attribute and link values of item and using them to form a new item within menu. As such, item itself is not really inserted, but rather, a menu item that is exactly the same as the one presently described by item.

This means that item is essentially useless after the insertion occurs. Any changes you make to it are ignored unless it is inserted again (at which point its updated values will be copied).

You should probably just free item once you're done.

There are many convenience functions to take care of common cases. See g_menu_insert(), g_menu_insert_section() and g_menu_insert_submenu() as well as "prepend" and "append" variants of each of these functions.

Since glibmm 2.32:

Parameters

  position | The position at which to insert the item.
  item | The MenuItem to insert.

void Gio::Menu::insert_section | ( | int | position,
|  | const Glib::ustring& | label,
|  | const Glib::RefPtr< MenuModel >& | section
| ) |  |

Convenience function for inserting a section menu item into menu.

Combine g_menu_item_new_section() and g_menu_insert_item() for a more flexible alternative.

Since glibmm 2.32:

Parameters

  position | The position at which to insert the item.
  label | The section label, or `0`.
  section | A MenuModel with the items of the section.

void Gio::Menu::insert_section | ( | int | position,
|  | const Glib::RefPtr< MenuModel >& | section
| ) |  |

A insert_section() convenience overload.

void Gio::Menu::insert_submenu | ( | int | position,
|  | const Glib::ustring& | label,
|  | const Glib::RefPtr< MenuModel >& | submenu
| ) |  |

Convenience function for inserting a submenu menu item into menu.

Combine g_menu_item_new_submenu() and g_menu_insert_item() for a more flexible alternative.

Since glibmm 2.32:

Parameters

  position | The position at which to insert the item.
  label | The section label, or `0`.
  submenu | A MenuModel with the items of the submenu.

void Gio::Menu::prepend | ( | const Glib::ustring& | label,
|  | const Glib::ustring& | detailed_action = `Glib::ustring()`
| ) |  |

Convenience function for prepending a normal menu item to the start of menu.

Combine g_menu_item_new() and g_menu_insert_item() for a more flexible alternative.

Since glibmm 2.32:

Parameters

  label | The section label, or `0`.
  detailed_action | The detailed action string, or `0`.

void Gio::Menu::prepend_item | ( | const Glib::RefPtr< MenuItem >& | item | ) |

Prepends item to the start of menu.

See g_menu_insert_item() for more information.

Since glibmm 2.32:

Parameters

  item | A MenuItem to prepend.

void Gio::Menu::prepend_section | ( | const Glib::ustring& | label,
|  | const Glib::RefPtr< MenuModel >& | section
| ) |  |

Convenience function for prepending a section menu item to the start of menu.

Combine g_menu_item_new_section() and g_menu_insert_item() for a more flexible alternative.

Since glibmm 2.32:

Parameters

  label | The section label, or `0`.
  section | A MenuModel with the items of the section.

void Gio::Menu::prepend_section | ( | const Glib::RefPtr< MenuModel >& | section | ) |

A prepend_section() convenience overload.

void Gio::Menu::prepend_submenu | ( | const Glib::ustring& | label,
|  | const Glib::RefPtr< MenuModel >& | submenu
| ) |  |

Convenience function for prepending a submenu menu item to the start of menu.

Combine g_menu_item_new_submenu() and g_menu_insert_item() for a more flexible alternative.

Since glibmm 2.32:

Parameters

  label | The section label, or `0`.
  submenu | A MenuModel with the items of the submenu.

void Gio::Menu::remove | ( | int | position | ) |

Removes an item from the menu.

position gives the index of the item to remove.

It is an error if position is not in range the range from 0 to one less than the number of items in the menu.

It is not possible to remove items by identity since items are added to the menu simply by copying their links and attributes (ie: identity of the item itself is not preserved).

Since glibmm 2.32:

Parameters

  position | The position of the item to remove.

void Gio::Menu::remove_all | ( |  | ) |

Removes all items in the menu.

Since glibmm 2.38:

## Friends And Related Function Documentation

Glib::RefPtr< Gio::Menu > wrap | ( | GMenu * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.